//
// Generated by SwagGen
// https://github.com/yonaskolb/SwagGen
//

import Foundation
import JSONUtilities

extension API.ApiFoyer {

    /** Permet de récupérer l'ensemble des immeubles présent dans le delta */
    public enum GetApiFoyerGetImmeubles {

        public static let service = APIService<Response>(id: "getApiFoyerGetImmeubles", tag: "Api Foyer", method: "GET", path: "/apiFoyer/getImmeubles", hasBody: false)

        public final class Request: APIRequest<Response> {

            public struct Options {

                public var latitude: String

                public var longitude: String

                public var delta: Int

                public init(latitude: String, longitude: String, delta: Int) {
                    self.latitude = latitude
                    self.longitude = longitude
                    self.delta = delta
                }
            }

            public var options: Options

            public init(options: Options) {
                self.options = options
                super.init(service: GetApiFoyerGetImmeubles.service)
            }

            /// convenience initialiser so an Option doesn't have to be created
            public convenience init(latitude: String, longitude: String, delta: Int) {
                let options = Options(latitude: latitude, longitude: longitude, delta: delta)
                self.init(options: options)
            }

            public override var parameters: [String: Any] {
                var params: JSONDictionary = [:]
                params["latitude"] = options.latitude
                params["longitude"] = options.longitude
                params["delta"] = options.delta
                return params
            }
        }

        public enum Response: APIResponseValue, CustomStringConvertible, CustomDebugStringConvertible {
            public typealias SuccessType = [Immeuble]

            /** Succes */
            case status200([Immeuble])

            public var success: [Immeuble]? {
                switch self {
                case .status200(let response): return response
                }
            }

            public var response: Any {
                switch self {
                case .status200(let response): return response
                }
            }

            public var statusCode: Int {
                switch self {
                case .status200: return 200
                }
            }

            public var successful: Bool {
                switch self {
                case .status200: return true
                }
            }

            public init(statusCode: Int, data: Data) throws {
                switch statusCode {
                case 200: self = try .status200(JSONDecoder.decode(data: data))
                default: throw APIError.unexpectedStatusCode(statusCode: statusCode, data: data)
                }
            }

            public var description: String {
                return "\(statusCode) \(successful ? "success" : "failure")"
            }

            public var debugDescription: String {
                var string = description
                let responseString = "\(response)"
                if responseString != "()" {
                    string += "\n\(responseString)"
                }
                return string
            }
        }
    }
}
